
#include "archives.hpp"


int archives::mount()
{
	printf("%s\n", path);
	char gvfs_archive_path[PATH_MAX];
	int i = 0, j = 0;
	for (i = 0; i < strlen(path); i++) {
		if (path[i] == '/') {
			/* authors of gvfsd-archive frontend cannot into URI decode */
			gvfs_archive_path[j++] = '%';
			gvfs_archive_path[j++] = '2';
			gvfs_archive_path[j++] = '5';
			gvfs_archive_path[j++] = '2';
			gvfs_archive_path[j++] = 'F';
		} else {
			gvfs_archive_path[j++] = path[i];
		}
	}
	
	char *gvfs_prefix = "archive://file%253A%252F%252F";
	char gvfs_archive[PATH_MAX];
	strcpy(gvfs_archive, gvfs_prefix);
	strcat(gvfs_archive, gvfs_archive_path);
	
	char *gvfs_mount = "gvfs-mount";
	char *const gvfs[] = {gvfs_mount, gvfs_archive, NULL};
	
	exec(gvfs_mount, gvfs);
	
	return 0;
}

int archives::umount()
{
	char gvfs_archive_path[PATH_MAX];
	int i = 0, j = 0;
	for (i = 0; i < strlen(path); i++) {
		if (path[i] == '/') {
			/* authors of gvfsd-archive frontend cannot into URI decode */
			gvfs_archive_path[j++] = '%';
			gvfs_archive_path[j++] = '2';
			gvfs_archive_path[j++] = '5';
			gvfs_archive_path[j++] = '2';
			gvfs_archive_path[j++] = 'F';
		} else {
			gvfs_archive_path[j++] = path[i];
		}
	}
	
	char *gvfs_prefix = "archive://file%253A%252F%252F";
	char gvfs_archive[PATH_MAX];
	strcpy(gvfs_archive, gvfs_prefix);
	strcat(gvfs_archive, gvfs_archive_path);
	
	char *gvfs_mount = "gvfs-mount";
	char *const gvfs[] = {gvfs_mount, "-u", gvfs_archive, NULL};
	
	exec(gvfs_mount, gvfs);
	
	return 0;
}
