#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stropts.h>
#include <linux/hdreg.h>

/* for more information see:
 * - /usr/include/linux/hdreg.h
 * - parted/libparted/arch/linux.c
 */

int main(int argc, const char *argv[])
{
	
	struct hd_driveid hd;
	int disk;
	disk = open("/dev/sda", O_RDONLY);
	ioctl(disk, HDIO_GET_IDENTITY, &hd);
	printf("Serial number: %s\n", hd.serial_no);
	char model[40];
	strncpy(model, hd.model, 40);
	printf("Model  number: %s\n", model);
	
	return 0;
}
