#include <sys/mount.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

int main(int argc, char const* argv[])
{
	
	const char *source = "/dev/sda8";
	const char *target = "/mnt/tmp";
	const char *filesystemtype = "ext2";
	unsigned long mountflags = 0;
	const void *data = "";
	
	/*
	const char *source = "/home/ia/tmp/.cryptdir";
	const char *target = "/home/ia/tmp/cryptdir";
	const char *filesystemtype = "ecryptfs";
	unsigned long mountflags = 0;
	const void *data = "key=passphrase"
	*/
	int result = mount(source, target, filesystemtype, mountflags, data);
	
	if (result)
		fprintf(stderr, "could not mount: %s\n", strerror(errno));
	
	return 0;
}

