/* basic formatting string parsing */

#include <stdio.h>
#include <string.h>

int main(int argc, const char *argv[])
{
	char *string = argv[1];
	if (!string) {
		string = "ymd";
	}
	
	printf("string: %s\n", string);
	int y = 2011;
	int m = 7;
	int d = 5;
	
	int n = strlen(string);
	int i = 0;
	
	for (i = 0; i < n; i++) {
		printf("i:n:c : %d %d %c\n", i, n, string[i]);
		if ((string[i] != 'd') && (string[i] != 'm') && (string[i] != 'y')) {
			printf("Wrong format! (%c)\n", string[i]);
			return -1;
		}
	}
	
	for (i = 0; i < n; i++) {
		if (string[i] == 'd') {
			printf("%.2d", d);
		} else if (string[i] == 'm') {
			printf("%.2d", m);
		} else if (string[i] == 'y') {
			printf("%d", y);
		} else {
			printf("X");
		}
	}
	printf("\n");
	return 0;
}
