
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <linux/fs.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char **argv)
{
	unsigned long long int size;
	const char *device = "/dev/sda";
	int dev = open(device, O_RDONLY);
	if (dev >= 0) {
		if (ioctl(dev, BLKGETSIZE64, &size) !=-1) {
			printf("%lld\n", size);
		}
	close(dev);
	} else {
		printf("Cannot open disk block device file!\n");
	}
	
	return 0;
}
