#!/usr/bin/make -f

test-lib: test-lib-cpp test-lib-c test-lib-py

test-lib-cpp: compile-lib-cpp
	LD_LIBRARY_PATH=../lib:${LD_LIBRARY_PATH} ./test-lib-cpp

test-lib-c: compile-lib-c
	LD_LIBRARY_PATH=../lib:${LD_LIBRARY_PATH} ./test-lib-c

test-lib-py:
	python lib-storage.py

compile-lib-cpp: lib-storage.cpp
	g++ -c lib-storage.cpp -o lib-storage-cpp.o
	g++ lib-storage-cpp.o -L../lib -lstorage -o test-lib-cpp

compile-lib-c: lib-storage.c
	gcc -c lib-storage.c -o lib-storage-c.o
	gcc lib-storage-c.o -L../lib -lstorage -o test-lib-c

clean:
	- rm -rf lib-storage-cpp.o lib-storage-c.o
	- rm -rf test-lib-cpp test-lib-c

.PHONY: test-lib-py
